#include <bits/stdc++.h>

using namespace std;

int main()
{
    int W,H,R,Q, p;
    bool grizao=false;
    cin>>W>>H>>R>>Q;
    int x[Q], y[Q];
    for (int i=1; i<=Q; i++)
    {
        cin>>p;
        if (p==1)
            cin>>x[i]>>y[i];
        else
        {
            cin>>x[i];
            y[i]=-1;
        }
    }
    int grizx=0, grizy=0;
    double long d;
    for (int i=1; i<=Q; i++)
    {
        if (y[i]!=-1)
        {
            grizx=x[i], grizy=y[i];
            grizao=true;
        }
        else
        {
            if (grizao==false)
                d=H;
            else
                {
                    if ((x[i]<=grizx-R) && (y[i]<=grizy-R))
                        d=H;
                else
                d=grizy-sqrt(R*R-(grizx-x[i])*(grizx-x[i]));
                }
            cout<<d<<endl;
        }
    }
}